/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: cyclic.h 96 2012-03-03 06:30:56Z nagasima $
 */

/*
 *		nh@\
 */

#ifndef TOPPERS_CYCLIC_H
#define TOPPERS_CYCLIC_H

#include <queue.h>
#include "time_event.h"

/*
 *  nhubN
 */
typedef struct cyclic_handler_initialization_block {
	ATR			cycatr;			/* nh */
	intptr_t	exinf;			/* nh̊g */
	CYCHDR		cychdr;			/* nh̋NԒn */
	RELTIM		cyctim;			/* nh̋N */
	RELTIM		cycphs;			/* nh̋Nʑ */
} CYCINIB;

/*
 *  nhǗubN
 */
typedef struct cyclic_handler_control_block {
	const CYCINIB *p_cycinib;	/* ubNւ̃|C^ */
	bool_t		cycsta;			/* nh̓ */
	EVTTIM		evttim;			/* ɎnhN鎞 */
	TMEVTB		tmevtb;			/* ^CCxgubN */
} CYCCB;

/*
 *  gpĂȂnhǗubÑXg
 */
extern QUEUE	free_cyccb;

/*
 *  nhID̍őlikernel_cfg.cj
 */
extern const ID	tmax_cycid;
extern const ID	tmax_scycid;

/*
 *  nhubÑGAikernel_cfg.cj
 */
extern const CYCINIB	cycinib_table[];
extern CYCINIB			acycinib_table[];

/*
 *  nhǗubÑGAikernel_cfg.cj
 */
extern CYCCB	cyccb_table[];

/*
 *  nhǗubNnhIDo߂̃}N
 */
#define	CYCID(p_cyccb)	((ID)(((p_cyccb) - cyccb_table) + TMIN_CYCID))

/*
 *  nh@\̏
 */
extern void	initialize_cyclic(void);

/*
 *  nhN[`
 */
extern void	call_cychdr(CYCCB *p_cyccb);

#endif /* TOPPERS_CYCLIC_H */
