/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: startup.c 96 2012-03-03 06:30:56Z nagasima $
 */

/*
 *		J[l̏ƏI
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>

/*
 *  g[XO}ÑftHg`
 */
#ifndef LOG_KER_ENTER
#define LOG_KER_ENTER()
#endif /* LOG_KER_ENTER */

#ifndef LOG_KER_LEAVE
#define LOG_KER_LEAVE()
#endif /* LOG_KER_LEAVE */

#ifndef LOG_EXT_KER_ENTER
#define LOG_EXT_KER_ENTER()
#endif /* LOG_EXT_KER_ENTER */

#ifndef LOG_EXT_KER_LEAVE
#define LOG_EXT_KER_LEAVE(ercd)
#endif /* LOG_EXT_KER_LEAVE */

#ifdef TOPPERS_sta_ker

/*
 *  J[lԃtO
 *
 *  X^[gAbv[`ŁCfalsei0jɏ邱Ƃ҂
 *  D
 */
bool_t	kerflg = false;

/*
 *  J[l̋N
 */
void
sta_ker(void)
{
	/*
	 *  ^[Qbgˑ̏
	 */
	target_initialize();

	/*
	 *  eW[̏
	 *
	 *  ^CCxgǗW[͑̃W[ɏ
	 *  KvD
	 */
	initialize_kmm();
	initialize_tmevt();
	initialize_object();

	/*
	 *  [`̎s
	 */ 
	call_inirtn();

	/*
	 *  J[l̊Jn
	 */
	kerflg = true;
	LOG_KER_ENTER();
	start_dispatch();
	assert(0);
}

#endif /* TOPPERS_sta_ker */

/*
 *  J[l̏I
 */
#ifdef TOPPERS_ext_ker

ER
ext_ker(void)
{
	SIL_PRE_LOC;

	LOG_EXT_KER_ENTER();

	/*
	 *  ݃bNԂɈڍs
	 */
	SIL_LOC_INT();

	/*
	 *  J[l̏I
	 */
	LOG_KER_LEAVE();
	kerflg = false;

	/*
	 *  J[l̏Ǐďo
	 *
	 *  ^XNReLXgɐ؂芷āCexit_kernelĂяoD
	 */
	call_exit_kernel();
	return(E_SYS);
}

/*
 *  J[l̏I
 */
void
exit_kernel(void)
{
	/*
	 *  I[`̎s
	 */
	call_terrtn();

	/*
	 *  ^[Qbgˑ̏I
	 */
	target_exit();
	assert(0);
}

#endif /* TOPPERS_ext_ker */

/*
 *  J[l̊t郁̈̊Ǘ
 *
 *  ̈擪珇Ɋ蓖āCꂽ̈ėp
 *  ǗW[D
 */
#ifdef TOPPERS_kermem
#ifndef OMIT_KMM_ALLOCONLY

static void	*kmm_brk;

void
initialize_kmm(void)
{
	kmm_brk = ((char *) kmm) + kmmsz;
}

void *
kernel_malloc(SIZE size)
{
	if (((char *) kmm_brk) - ((char *) kmm) >= size) {
		kmm_brk = ((char *) kmm_brk) - size;
		return(kmm_brk);
	}
	else {
		return(NULL);
	}
}

void
kernel_free(void *ptr)
{
}

#endif /* OMIT_KMM_ALLOCONLY */
#endif /* TOPPERS_kermem */
