/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2005-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: task_refer.c 96 2012-03-03 06:30:56Z nagasima $
 */

/*
 *		^XN̏ԎQƋ@\
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "wait.h"
#include "semaphore.h"
#include "eventflag.h"
#include "dataqueue.h"
#include "pridataq.h"
#include "mailbox.h"
#include "mempfix.h"
#include "mempvar.h"
#include "time_event.h"

/*
 *  g[XO}ÑftHg`
 */
#ifndef LOG_REF_TSK_ENTER
#define LOG_REF_TSK_ENTER(tskid, pk_rtsk)
#endif /* LOG_REF_TSK_ENTER */

#ifndef LOG_REF_TSK_LEAVE
#define LOG_REF_TSK_LEAVE(ercd, pk_rtsk)
#endif /* LOG_REF_TSK_LEAVE */

/*
 *  ^XN̏ԎQ
 */
#ifdef TOPPERS_ref_tsk

ER
ref_tsk(ID tskid, T_RTSK *pk_rtsk)
{
	TCB		*p_tcb;
	uint_t	tstat;
	ER		ercd;

	LOG_REF_TSK_ENTER(tskid, pk_rtsk);
	CHECK_TSKCTX_UNL();
	CHECK_TSKID_SELF(tskid);
	p_tcb = get_tcb_self(tskid);

	t_lock_cpu();
	tstat = p_tcb->tstat;
	if (p_tcb->p_tinib->tskatr == TA_NOEXS) {
		ercd = E_NOEXS;
	}
	else {
		if (TSTAT_DORMANT(tstat)) {
			/*
	 		 *  Ώۃ^XNx~Ԃ̏ꍇ
			 */
			pk_rtsk->tskstat = TTS_DMT;
		}
		else {
			/*
	 		 *  ^XNԂ̎o
			 */
			if (TSTAT_SUSPENDED(tstat)) {
				if (TSTAT_WAITING(tstat)) {
					pk_rtsk->tskstat = TTS_WAS;
				}
				else {
					pk_rtsk->tskstat = TTS_SUS;
				}
			}
			else if (TSTAT_WAITING(tstat)) {
				pk_rtsk->tskstat = TTS_WAI;
			}
			else if (p_tcb == p_runtsk) {
				pk_rtsk->tskstat = TTS_RUN;
			}
			else {
				pk_rtsk->tskstat = TTS_RDY;
			}

			/*
	 		 *  ݗDxƃx[XDx̎o
			 */
			pk_rtsk->tskpri = EXT_TSKPRI(p_tcb->priority);
			pk_rtsk->tskbpri = EXT_TSKPRI(p_tcb->priority);

			if (TSTAT_WAITING(tstat)) {
				/*
		 		 *  ҂vƑ҂Ώۂ̃IuWFNgID̎o
				 */
				switch (tstat & TS_WAIT_MASK) {
				case TS_WAIT_SLP:
					pk_rtsk->tskwait = TTW_SLP;
					break;
				case TS_WAIT_DLY:
					pk_rtsk->tskwait = TTW_DLY;
					break;
				case TS_WAIT_SEM:
					pk_rtsk->tskwait = TTW_SEM;
					pk_rtsk->wobjid = SEMID(((WINFO_SEM *)(p_tcb->p_winfo))
																->p_semcb);
					break;
				case TS_WAIT_FLG:
					pk_rtsk->tskwait = TTW_FLG;
					pk_rtsk->wobjid = FLGID(((WINFO_FLG *)(p_tcb->p_winfo))
																->p_flgcb);
					break;
				case TS_WAIT_SDTQ:
					pk_rtsk->tskwait = TTW_SDTQ;
					pk_rtsk->wobjid = DTQID(((WINFO_DTQ *)(p_tcb->p_winfo))
																->p_dtqcb);
					break;
				case TS_WAIT_RDTQ:
					pk_rtsk->tskwait = TTW_RDTQ;
					pk_rtsk->wobjid = DTQID(((WINFO_DTQ *)(p_tcb->p_winfo))
																->p_dtqcb);
					break;
				case TS_WAIT_SPDQ:
					pk_rtsk->tskwait = TTW_SPDQ;
					pk_rtsk->wobjid = PDQID(((WINFO_PDQ *)(p_tcb->p_winfo))
																->p_pdqcb);
					break;
				case TS_WAIT_RPDQ:
					pk_rtsk->tskwait = TTW_RPDQ;
					pk_rtsk->wobjid = PDQID(((WINFO_PDQ *)(p_tcb->p_winfo))
																->p_pdqcb);
					break;
				case TS_WAIT_MBX:
					pk_rtsk->tskwait = TTW_MBX;
					pk_rtsk->wobjid = MBXID(((WINFO_MBX *)(p_tcb->p_winfo))
																->p_mbxcb);
					break;
				case TS_WAIT_MPF:
					pk_rtsk->tskwait = TTW_MPF;
					pk_rtsk->wobjid = MPFID(((WINFO_MPF *)(p_tcb->p_winfo))
																->p_mpfcb);
					break;
				case TS_WAIT_MPL:
					pk_rtsk->tskwait = TTW_MPL;
					pk_rtsk->wobjid = MPLID(((WINFO_MPL *)(p_tcb->p_winfo))
																->p_mplcb);
					break;
				}

				/*
		 		 *  ^CAEg܂ł̎Ԃ̎o
				 */
				if (p_tcb->p_winfo->p_tmevtb != NULL) {
					pk_rtsk->lefttmo
							= (TMO) tmevt_lefttim(p_tcb->p_winfo->p_tmevtb);
				}
				else {
					pk_rtsk->lefttmo = TMO_FEVR;
				}
			}

			/*
	 		 *  NvL[CO̎o
			 */
			pk_rtsk->wupcnt = p_tcb->wupque ? 1U : 0U;
		}

		/*
		 *  NvL[CO̎o
		 */
		pk_rtsk->actcnt = p_tcb->actque ? 1U : 0U;
		ercd = E_OK;
	}
	t_unlock_cpu();

  error_exit:
	LOG_REF_TSK_LEAVE(ercd, pk_rtsk);
	return(ercd);
}

#endif /* TOPPERS_ref_tsk */
